#Author: Oliver-Matis Lill
#Simply try all possible combinations
#of flipping the switches
#Time Complexity: O(2^M)
inf=open('diskosis.txt', 'r')
outf=open('diskoval.txt', 'w')

L=int(inf.readline())
pts=[]

N=int(inf.readline())
span=[]

for i in range(N):
	a, b = map(int, inf.readline().split(' ') )
	b+=1
	pts.append(a)
	pts.append(b)
	span.append(a)
	span.append(b)


M=int(inf.readline())
edge=[]

for i in range(M):
	a, b = map(int, inf.readline().split(' ') )
	b+=1
	edge.append([a, b])
	pts.append(a)
	pts.append(b)

pts = list(set(pts))


ptind={}
for i in range(len(pts)):
	ptind[pts[i]] = i

for i in range(2*N):
	span[i] = ptind[span[i]]

for i in range(M):
	edge[i] = [ptind[edge[i][0]], ptind[edge[i][1]] ]




#-------------------------------------------------------------
#Finished processing input, try picks

switch = [0 for i in range(len(pts))]
switched = 2*N


def performswitch(pos):
	global switched
	switched += (switch[pos]+1)%2 - switch[pos]
	switch[pos] = (switch[pos]+1)%2




for p in span:
	switch[p] = 1


def solve(ind):
	if ind == M and switched == 0:
		return []
	
	if switched > 2*(M-ind):
		return None
	
	
	#try switching
	p1, p2 = edge[ind]
	performswitch(p1)
	performswitch(p2)
	
	ret=solve(ind+1)
	if not ret == None:
		return ret + [1]
	
	performswitch(p1)
	performswitch(p2)
	
	ret = solve(ind+1)
	if not ret == None:
		return ret + [0]
	
	return None



result = solve(0)

if(result == None):
	outf.write("EI\n")
else:
	outf.write("JAH\n")
	
	result.reverse()
	
	for p in result:
		outf.write(str(p) + ' ')
	outf.write('\n')

































