#include <fstream>
#include <string>
#include <vector>
#include <set>
using namespace std;

ifstream sis("ipgsis.txt");
ofstream val("ipgval.txt");

set<string> baas;
set<string> vead;
vector<string> logi;

bool grep(const string &s1, const string &s2) {
	for (int i = 0; i <= int(s2.length()) - int(s1.length()); ++i) {
		bool eri = false;
		for (int j = 0; j < s1.length() && !eri; ++j) {
			if (s1[j] != '.' && s1[j] != s2[i + j]) {
				eri = true;
			}
		}
		if (!eri) {
			return true;
		}
	}
	return false;
}

int main() {
	int n;
	string s;
	sis >> n;
	for (int i = 0; i < n; ++i) {
		sis >> s;
		if (baas.find(s) != baas.end()) {
			continue;
		}
		if (vead.find(s) != vead.end()) {
			continue;
		}
		bool viga = false;
		for (set<string>::iterator j = baas.begin(); j != baas.end() && !viga; ++j) {
			viga |= grep(s, *j);
		}
		if (viga) {
			vead.insert(s);
			logi.push_back(s);
		} else {
			baas.insert(s);
		}
	}

	val << logi.size() << "\n";
	for (int i = 0; i < logi.size(); ++i) {
		val << logi[i] << "\n";
	}
	return 0;
}
